Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::Texture Class Reference

Texture pure virtual base class that encapsulates OpenGl texture functionality common to the various types of OSG textures. More...

Inheritance diagram for osg::Texture:

[legend]
List of all members.

## Public Types
typedef std::list< ref_ptr< TextureObject > > | TextureObjectList
typedef std::map< unsigned int, TextureObjectList > | TextureObjectListMap
enum | WrapParameter { WRAP_S, WRAP_T, WRAP_R }
enum | WrapMode { CLAMP = GL_CLAMP, CLAMP_TO_EDGE = GL_CLAMP_TO_EDGE, CLAMP_TO_BORDER = GL_CLAMP_TO_BORDER_ARB, REPEAT = GL_REPEAT, MIRROR = GL_MIRRORED_REPEAT_IBM }
enum | FilterParameter { MIN_FILTER, MAG_FILTER }
enum | FilterMode { LINEAR = GL_LINEAR, LINEAR_MIPMAP_LINEAR = GL_LINEAR_MIPMAP_LINEAR, LINEAR_MIPMAP_NEAREST = GL_LINEAR_MIPMAP_NEAREST, NEAREST = GL_NEAREST, NEAREST_MIPMAP_LINEAR = GL_NEAREST_MIPMAP_LINEAR, NEAREST_MIPMAP_NEAREST = GL_NEAREST_MIPMAP_NEAREST }
enum | InternalFormatMode { USE_IMAGE_DATA_FORMAT, USE_USER_DEFINED_FORMAT, USE_ARB_COMPRESSION, USE_S3TC_DXT1_COMPRESSION, USE_S3TC_DXT3_COMPRESSION, USE_S3TC_DXT5_COMPRESSION }
enum | ShadowCompareFunc { LEQUAL = GL_LEQUAL, GEQUAL = GL_GEQUAL }
enum | ShadowTextureMode { LUMINANCE = GL_LUMINANCE, INTENSITY = GL_INTENSITY, ALPHA = GL_ALPHA }
## Public Member Functions
| Texture ()
| Texture (const Texture &text, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
virtual osg::Object * | cloneType () const=0
| Clone the type of an attribute, with Object* return type.
virtual osg::Object * | clone (const CopyOp &copyop) const=0
| Clone an attribute, with Object* return type.
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | libraryName () const
| Return the name of the attribute's library.
virtual const char * | className () const
| Return the name of the attribute's class type.
virtual Type | getType () const
| Return the Type identifier of the attribute's class type.
virtual bool | isTextureAttribute () const
| Return true if StateAttribute is a type which controls texturing and needs to be issued w.r.t to specific texture unit.
virtual GLenum | getTextureTarget () const=0
virtual bool | getModeUsage (ModeUsage &usage) const
| Return the modes associated with this StateAttribute.
void | setWrap (WrapParameter which, WrapMode wrap)
| Sets the texture wrap mode.
WrapMode | getWrap (WrapParameter which) const
| Gets the texture wrap mode.
void | setBorderColor (const Vec4 &color)
| Sets the border color.
const Vec4 & | getBorderColor () const
| Gets the border color.
void | setBorderWidth (GLint width)
| Sets the border width.
GLint | getBorderWidth () const
void | setFilter (FilterParameter which, FilterMode filter)
| Sets the texture filter mode.
FilterMode | getFilter (FilterParameter which) const
| Gets the texture filter mode.
void | setMaxAnisotropy (float anis)
| Sets the maximum anisotropy value, default value is 1.0 for no anisotropic filtering.
float | getMaxAnisotropy () const
| Gets the maximum anisotropy value.
void | setUseHardwareMipMapGeneration (bool useHardwareMipMapGeneration)
| Sets the hardware mipmap generation hint.
bool | getUseHardwareMipMapGeneration () const
| Gets the hardware mipmap generation hint.
void | setUnRefImageDataAfterApply (bool flag)
| Sets whether or not the apply() function will unreference the image data.
bool | getUnRefImageDataAfterApply () const
| Gets whether or not apply() unreferences image data.
void | setClientStorageHint (bool flag)
| Sets whether to use client storage for the texture, if supported by the graphics system.
bool | getClientStorageHint () const
| Gets whether to use client storage for the texture.
void | setResizeNonPowerOfTwoHint (bool flag)
| Sets whether to force the texture to resize images that have dimensions that are not a power of two.
bool | getResizeNonPowerOfTwoHint () const
| Gets whether texture will force non power to two images to be resized.
void | setInternalFormatMode (InternalFormatMode mode)
| Sets the internal texture format mode.
InternalFormatMode | getInternalFormatMode () const
| Gets the internal texture format mode.
void | setInternalFormat (GLint internalFormat)
| Sets the internal texture format.
GLint | getInternalFormat () const
| Gets the internal texture format.
bool | isCompressedInternalFormat () const
| Return true if the internal format is one of the compressed formats.
void | setSourceFormat (GLenum sourceFormat)
| Sets the external source image format, used as a fallback when no osg::Image is attached to provide the source image format.
GLenum | getSourceFormat () const
| Gets the external source image format.
void | setSourceType (GLenum sourceType)
| Sets the external source data type, used as a fallback when no osg::Image is attached to provide the source image format.
GLenum | getSourceType () const
| Gets the external source data type.
TextureObject * | getTextureObject (unsigned int contextID) const
| Returns a pointer to the texture object for the current context.
void | dirtyTextureObject ()
| Forces a recompile on next apply() of associated OpenGL texture objects.
bool | areAllTextureObjectsLoaded () const
| Returns true if the texture objects for all the required graphics contexts are loaded.
unsigned int & | getTextureParameterDirty (unsigned int contextID) const
| Gets the dirty flag for the current contextID.
void | dirtyTextureParameters ()
| Force a reset on next apply() of associated OpenGL texture parameters.
void | setShadowComparison (bool flag)
| Sets GL_TEXTURE_COMPARE_MODE_ARB to GL_COMPARE_R_TO_TEXTURE_ARB See http://oss.sgi.com/projects/ogl-sample/registry/ARB/shadow.txt.
void | setShadowCompareFunc (ShadowCompareFunc func)
| Sets shadow texture comparison function.
ShadowCompareFunc | getShadowCompareFunc ()
void | setShadowTextureMode (ShadowTextureMode mode)
| Sets shadow texture mode after comparison.
ShadowTextureMode | getShadowTextureMode ()
void | setShadowAmbient (float shadow_ambient)
| Sets the TEXTURE_COMPARE_FAIL_VALUE_ARB texture parameter.
float | getShadowAmbient ()
virtual void | setImage (unsigned int face, Image *image)=0
| Sets the texture image for the specified face.
virtual Image * | getImage (unsigned int face)=0
| Gets the texture image for the specified face.
virtual const Image * | getImage (unsigned int face) const=0
| Gets the const texture image for specified face.
virtual unsigned int | getNumImages () const=0
| Gets the number of images that can be assigned to this Texture.
void | setReadPBuffer (GraphicsContext *context)
| Set the PBuffer graphis context to read from when using PBuffers for RenderToTexture.
GraphicsContext * | getReadPBuffer ()
| Get the PBuffer graphis context to read from when using PBuffers for RenderToTexture.
virtual void | apply (State &state) const=0
| Texture is a pure virtual base class, apply must be overriden.
virtual void | compileGLObjects (State &state) const
| Calls apply(state) to compile the texture.
virtual void | releaseGLObjects (State *state=0) const
| If State is non-zero, this function releases OpenGL objects for the specified graphics context.
void | applyTexImage2D_load (State &state, GLenum target, const Image *image, GLsizei width, GLsizei height, GLsizei numMipmapLevels) const
| Helper method.
void | applyTexImage2D_subload (State &state, GLenum target, const Image *image, GLsizei width, GLsizei height, GLint inInternalFormat, GLsizei numMipmapLevels) const
| Helper method.
void | takeTextureObjects (TextureObjectListMap &toblm)
| Takes the active texture objects from the Texture and places them in the specified TextureObjectListMap.
## Static Public Member Functions
Extensions * | getExtensions (unsigned int contextID, bool createIfNotInitalized)
| Gets the extension for the specified context.
void | setExtensions (unsigned int contextID, Extensions *extensions)
| Overrides Extensions objects across graphics contexts.
TextureObject * | generateTextureObject (unsigned int contextID, GLenum target)
TextureObject * | generateTextureObject (unsigned int contextID, GLenum target, GLint numMipmapLevels, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border)
void | setMinimumNumberOfTextureObjectsToRetainInCache (unsigned int minimum)
| Set the minimum number of texture objects to retain in the deleted display list cache.
unsigned int | getMinimumNumberOfTextureObjectsToRetainInCache ()
| Get the minimum number of display lists to retain in the deleted display list cache.
void | flushAllDeletedTextureObjects (unsigned int contextID)
void | flushDeletedTextureObjects (unsigned int contextID, double currentTime, double &availableTime)
## Static Public Attributes
unsigned int | s_numberTextureReusedLastInLastFrame
unsigned int | s_numberNewTextureInLastFrame
unsigned int | s_numberDeletedTextureInLastFrame
## Protected Types
typedef buffered_value< unsigned int > | TexParameterDirtyList
typedef buffered_object< ref_ptr< TextureObject > > | TextureObjectBuffer
## Protected Member Functions
virtual | ~Texture ()
virtual void | computeInternalFormat () const=0
void | computeInternalFormatWithImage (const osg::Image &image) const
void | computeRequiredTextureDimensions (State &state, const osg::Image &image, GLsizei &width, GLsizei &height, GLsizei &numMipmapLevels) const
bool | isCompressedInternalFormat (GLint internalFormat) const
void | getCompressedSize (GLenum internalFormat, GLint width, GLint height, GLint depth, GLint &blockSize, GLint &size) const
void | applyTexParameters (GLenum target, State &state) const
| Helper method.
int | compareTexture (const Texture &rhs) const
| Returns -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
## Protected Attributes
TexParameterDirtyList | _texParametersDirtyList
WrapMode | _wrap_s
WrapMode | _wrap_t
WrapMode | _wrap_r
FilterMode | _min_filter
FilterMode | _mag_filter
float | _maxAnisotropy
bool | _useHardwareMipMapGeneration
bool | _unrefImageDataAfterApply
bool | _clientStorageHint
bool | _resizeNonPowerOfTwoHint
Vec4 | _borderColor
GLint | _borderWidth
InternalFormatMode | _internalFormatMode
GLint | _internalFormat
GLenum | _sourceFormat
GLenum | _sourceType
bool | _use_shadow_comparison
ShadowCompareFunc | _shadow_compare_func
ShadowTextureMode | _shadow_texture_mode
float | _shadow_ambient
TextureObjectBuffer | _textureObjectBuffer
ref_ptr< GraphicsContext > | _readPBuffer

## Detailed Description

Texture pure virtual base class that encapsulates OpenGl texture functionality common to the various types of OSG textures.

## Member Typedef Documentation

typedef buffered_value<unsigned int> osg::Texture::TexParameterDirtyList`[protected]`

typedef buffered_object< ref_ptr<TextureObject> > osg::Texture::TextureObjectBuffer`[protected]`

typedef std::list< ref_ptr<TextureObject> > osg::Texture::TextureObjectList

typedef std::map<unsigned int, TextureObjectList > osg::Texture::TextureObjectListMap

## Member Enumeration Documentation

enum osg::Texture::FilterMode

  | Enumeration values:
  LINEAR |
  LINEAR_MIPMAP_LINEAR |
  LINEAR_MIPMAP_NEAREST |
  NEAREST |
  NEAREST_MIPMAP_LINEAR |
  NEAREST_MIPMAP_NEAREST |

enum osg::Texture::FilterParameter

  | Enumeration values:
  MIN_FILTER |
  MAG_FILTER |

enum osg::Texture::InternalFormatMode

  | Enumeration values:
  USE_IMAGE_DATA_FORMAT |
  USE_USER_DEFINED_FORMAT |
  USE_ARB_COMPRESSION |
  USE_S3TC_DXT1_COMPRESSION |
  USE_S3TC_DXT3_COMPRESSION |
  USE_S3TC_DXT5_COMPRESSION |

enum osg::Texture::ShadowCompareFunc

  | Enumeration values:
  LEQUAL |
  GEQUAL |

enum osg::Texture::ShadowTextureMode

  | Enumeration values:
  LUMINANCE |
  INTENSITY |
  ALPHA |

enum osg::Texture::WrapMode

  | Enumeration values:
  CLAMP |
  CLAMP_TO_EDGE |
  CLAMP_TO_BORDER |
  REPEAT |
  MIRROR |

enum osg::Texture::WrapParameter

  | Enumeration values:
  WRAP_S |
  WRAP_T |
  WRAP_R |

## Constructor & Destructor Documentation

osg::Texture::Texture | ( |  | ) |

osg::Texture::Texture | ( | const Texture & | text,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) |

| Copy constructor using CopyOp to manage deep vs shallow copy.

virtual osg::Texture::~Texture | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

virtual void osg::Texture::apply | ( | State & | state | ) | const`[pure virtual]`

| Texture is a pure virtual base class, apply must be overriden. Implements osg::StateAttribute. Implemented in osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, osg::TextureRectangle, and osgText::Font::GlyphTexture.

void osg::Texture::applyTexImage2D_load | ( | State & | state,
|  | GLenum | target,
|  | const Image * | image,
|  | GLsizei | width,
|  | GLsizei | height,
|  | GLsizei | numMipmapLevels
| ) | const

| Helper method. Creates the texture, but doesn't set or use a texture binding. Note: Don't call this method directly unless you're implementing a subload callback.

void osg::Texture::applyTexImage2D_subload | ( | State & | state,
|  | GLenum | target,
|  | const Image * | image,
|  | GLsizei | width,
|  | GLsizei | height,
|  | GLint | inInternalFormat,
|  | GLsizei | numMipmapLevels
| ) | const

| Helper method. Subloads images into the texture, but doesn't set or use a texture binding. Note: Don't call this method directly unless you're implementing a subload callback.

void osg::Texture::applyTexParameters | ( | GLenum | target,
|  | State & | state
| ) | const`[protected]`

| Helper method. Sets texture paramters. Reimplemented in osg::TextureRectangle.

bool osg::Texture::areAllTextureObjectsLoaded | ( |  | ) | const

| Returns true if the texture objects for all the required graphics contexts are loaded.

virtual const char* osg::Texture::className | ( |  | ) | const`[inline, virtual]`

| Return the name of the attribute's class type. Reimplemented from osg::StateAttribute. Reimplemented in osgText::Font::GlyphTexture.

virtual osg::Object* osg::Texture::clone | ( | const CopyOp & | copyop | ) | const`[pure virtual]`

| Clone an attribute, with Object* return type. Must be defined by derived classes. Implements osg::StateAttribute.

virtual osg::Object* osg::Texture::cloneType | ( |  | ) | const`[pure virtual]`

| Clone the type of an attribute, with Object* return type. Must be defined by derived classes. Implements osg::StateAttribute.

int osg::Texture::compareTexture | ( | const Texture & | rhs | ) | const`[protected]`

| Returns -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

virtual void osg::Texture::compileGLObjects | ( | State & | state | ) | const`[virtual]`

| Calls apply(state) to compile the texture. Reimplemented from osg::StateAttribute.

virtual void osg::Texture::computeInternalFormat | ( |  | ) | const`[protected, pure virtual]`

| Implemented in osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, and osg::TextureRectangle.

void osg::Texture::computeInternalFormatWithImage | ( | const osg::Image & | image | ) | const`[protected]`

void osg::Texture::computeRequiredTextureDimensions | ( | State & | state,
|  | const osg::Image & | image,
|  | GLsizei & | width,
|  | GLsizei & | height,
|  | GLsizei & | numMipmapLevels
| ) | const`[protected]`

void osg::Texture::dirtyTextureObject | ( |  | ) |

| Forces a recompile on next apply() of associated OpenGL texture objects.

void osg::Texture::dirtyTextureParameters | ( |  | ) |

| Force a reset on next apply() of associated OpenGL texture parameters.

void osg::Texture::flushAllDeletedTextureObjects | ( | unsigned int | contextID | ) | `[static]`

void osg::Texture::flushDeletedTextureObjects | ( | unsigned int | contextID,
|  | double | currentTime,
|  | double & | availableTime
| ) | `[static]`

TextureObject* osg::Texture::generateTextureObject | ( | unsigned int | contextID,
|  | GLenum | target,
|  | GLint | numMipmapLevels,
|  | GLenum | internalFormat,
|  | GLsizei | width,
|  | GLsizei | height,
|  | GLsizei | depth,
|  | GLint | border
| ) | `[static]`

TextureObject* osg::Texture::generateTextureObject | ( | unsigned int | contextID,
|  | GLenum | target
| ) | `[static]`

const Vec4& osg::Texture::getBorderColor | ( |  | ) | const`[inline]`

| Gets the border color.

GLint osg::Texture::getBorderWidth | ( |  | ) | const`[inline]`

bool osg::Texture::getClientStorageHint | ( |  | ) | const`[inline]`

| Gets whether to use client storage for the texture.

void osg::Texture::getCompressedSize | ( | GLenum | internalFormat,
|  | GLint | width,
|  | GLint | height,
|  | GLint | depth,
|  | GLint & | blockSize,
|  | GLint & | size
| ) | const`[protected]`

Extensions* osg::Texture::getExtensions | ( | unsigned int | contextID,
|  | bool | createIfNotInitalized
| ) | `[static]`

| Gets the extension for the specified context. Creates the Extensions object for that context if it doesn't exist. Returns NULL if the Extensions object for the context doesn't exist and the createIfNotInitalized flag is false. Reimplemented in osg::Texture3D, and osg::TextureCubeMap.

FilterMode osg::Texture::getFilter | ( | FilterParameter | which | ) | const

| Gets the texture filter mode.

virtual const Image* osg::Texture::getImage | ( | unsigned int | face | ) | const`[pure virtual]`

| Gets the const texture image for specified face. Implemented in osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, and osg::TextureRectangle.

virtual Image* osg::Texture::getImage | ( | unsigned int | face | ) | `[pure virtual]`

| Gets the texture image for the specified face. Implemented in osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, and osg::TextureRectangle.

GLint osg::Texture::getInternalFormat | ( |  | ) | const`[inline]`

| Gets the internal texture format.

InternalFormatMode osg::Texture::getInternalFormatMode | ( |  | ) | const`[inline]`

| Gets the internal texture format mode.

float osg::Texture::getMaxAnisotropy | ( |  | ) | const`[inline]`

| Gets the maximum anisotropy value.

unsigned int osg::Texture::getMinimumNumberOfTextureObjectsToRetainInCache | ( |  | ) | `[static]`

| Get the minimum number of display lists to retain in the deleted display list cache.

virtual bool osg::Texture::getModeUsage | ( | ModeUsage & | usage | ) | const`[inline, virtual]`

| Return the modes associated with this StateAttribute. Reimplemented from osg::StateAttribute.

virtual unsigned int osg::Texture::getNumImages | ( |  | ) | const`[pure virtual]`

| Gets the number of images that can be assigned to this Texture. Implemented in osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, and osg::TextureRectangle.

GraphicsContext* osg::Texture::getReadPBuffer | ( |  | ) | `[inline]`

| Get the PBuffer graphis context to read from when using PBuffers for RenderToTexture.

bool osg::Texture::getResizeNonPowerOfTwoHint | ( |  | ) | const`[inline]`

| Gets whether texture will force non power to two images to be resized.

float osg::Texture::getShadowAmbient | ( |  | ) | `[inline]`

ShadowCompareFunc osg::Texture::getShadowCompareFunc | ( |  | ) | `[inline]`

ShadowTextureMode osg::Texture::getShadowTextureMode | ( |  | ) | `[inline]`

GLenum osg::Texture::getSourceFormat | ( |  | ) | const`[inline]`

| Gets the external source image format.

GLenum osg::Texture::getSourceType | ( |  | ) | const`[inline]`

| Gets the external source data type.

TextureObject* osg::Texture::getTextureObject | ( | unsigned int | contextID | ) | const`[inline]`

| Returns a pointer to the texture object for the current context.

unsigned int& osg::Texture::getTextureParameterDirty | ( | unsigned int | contextID | ) | const`[inline]`

| Gets the dirty flag for the current contextID.

virtual GLenum osg::Texture::getTextureTarget | ( |  | ) | const`[pure virtual]`

| Implemented in osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, and osg::TextureRectangle.

virtual Type osg::Texture::getType | ( |  | ) | const`[inline, virtual]`

| Return the Type identifier of the attribute's class type. Implements osg::StateAttribute.

bool osg::Texture::getUnRefImageDataAfterApply | ( |  | ) | const`[inline]`

| Gets whether or not apply() unreferences image data.

bool osg::Texture::getUseHardwareMipMapGeneration | ( |  | ) | const`[inline]`

| Gets the hardware mipmap generation hint.

WrapMode osg::Texture::getWrap | ( | WrapParameter | which | ) | const

| Gets the texture wrap mode.

bool osg::Texture::isCompressedInternalFormat | ( | GLint | internalFormat | ) | const`[protected]`

bool osg::Texture::isCompressedInternalFormat | ( |  | ) | const

| Return true if the internal format is one of the compressed formats.

virtual bool osg::Texture::isSameKindAs | ( | const osg::Object * | obj | ) | const`[inline, virtual]`

virtual bool osg::Texture::isTextureAttribute | ( |  | ) | const`[inline, virtual]`

| Return true if StateAttribute is a type which controls texturing and needs to be issued w.r.t to specific texture unit. Reimplemented from osg::StateAttribute.

virtual const char* osg::Texture::libraryName | ( |  | ) | const`[inline, virtual]`

| Return the name of the attribute's library. Reimplemented from osg::StateAttribute.

virtual void osg::Texture::releaseGLObjects | ( | State * | state = 0 | ) | const`[virtual]`

| If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objexts for all graphics contexts. Reimplemented from osg::StateAttribute.

void osg::Texture::setBorderColor | ( | const Vec4 & | color | ) | `[inline]`

| Sets the border color. Only used when wrap mode is CLAMP_TO_BORDER.

void osg::Texture::setBorderWidth | ( | GLint | width | ) | `[inline]`

| Sets the border width.

void osg::Texture::setClientStorageHint | ( | bool | flag | ) | `[inline]`

| Sets whether to use client storage for the texture, if supported by the graphics system. Note: If enabled, and the graphics system supports it, the osg::Image(s) associated with this texture cannot be deleted, so the UnRefImageDataAfterApply flag would be ignored.

void osg::Texture::setExtensions | ( | unsigned int | contextID,
|  | Extensions * | extensions
| ) | `[static]`

| Overrides Extensions objects across graphics contexts. Typically used to ensure the same lowest common denominator of extensions on sustems with different graphics pipes. Reimplemented in osg::Texture3D, and osg::TextureCubeMap.

void osg::Texture::setFilter | ( | FilterParameter | which,
|  | FilterMode | filter
| ) |

| Sets the texture filter mode.

virtual void osg::Texture::setImage | ( | unsigned int | face,
|  | Image * | image
| ) | `[pure virtual]`

| Sets the texture image for the specified face. Implemented in osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, and osg::TextureRectangle.

void osg::Texture::setInternalFormat | ( | GLint | internalFormat | ) | `[inline]`

| Sets the internal texture format. Implicitly sets the internalFormatMode to USE_USER_DEFINED_FORMAT.

void osg::Texture::setInternalFormatMode | ( | InternalFormatMode | mode | ) | `[inline]`

| Sets the internal texture format mode. Note: If the texture format is USE_IMAGE_DATA_FORMAT, USE_ARB_COMPRESSION, or USE_S3TC_COMPRESSION, the internal format mode is set automatically and will overwrite the previous _internalFormat.

void osg::Texture::setMaxAnisotropy | ( | float | anis | ) |

| Sets the maximum anisotropy value, default value is 1.0 for no anisotropic filtering. If hardware does not support anisotropic filtering, use normal filtering (equivilant to a max anisotropy value of 1.0. Valid range is 1.0f upwards. The maximum value depends on the graphics system.

void osg::Texture::setMinimumNumberOfTextureObjectsToRetainInCache | ( | unsigned int | minimum | ) | `[static]`

| Set the minimum number of texture objects to retain in the deleted display list cache.

void osg::Texture::setReadPBuffer | ( | GraphicsContext * | context | ) | `[inline]`

| Set the PBuffer graphis context to read from when using PBuffers for RenderToTexture.

void osg::Texture::setResizeNonPowerOfTwoHint | ( | bool | flag | ) | `[inline]`

| Sets whether to force the texture to resize images that have dimensions that are not a power of two. If enabled, NPOT images will be resized, whether or not NPOT textures are supported by the hardware. If disabled, NPOT images will not be resized if supported by hardware.

void osg::Texture::setShadowAmbient | ( | float | shadow_ambient | ) | `[inline]`

| Sets the TEXTURE_COMPARE_FAIL_VALUE_ARB texture parameter. See http://oss.sgi.com/projects/ogl-sample/registry/ARB/shadow_ambient.txt.

void osg::Texture::setShadowCompareFunc | ( | ShadowCompareFunc | func | ) | `[inline]`

| Sets shadow texture comparison function.

void osg::Texture::setShadowComparison | ( | bool | flag | ) | `[inline]`

| Sets GL_TEXTURE_COMPARE_MODE_ARB to GL_COMPARE_R_TO_TEXTURE_ARB See http://oss.sgi.com/projects/ogl-sample/registry/ARB/shadow.txt.

void osg::Texture::setShadowTextureMode | ( | ShadowTextureMode | mode | ) | `[inline]`

| Sets shadow texture mode after comparison.

void osg::Texture::setSourceFormat | ( | GLenum | sourceFormat | ) | `[inline]`

| Sets the external source image format, used as a fallback when no osg::Image is attached to provide the source image format.

void osg::Texture::setSourceType | ( | GLenum | sourceType | ) | `[inline]`

| Sets the external source data type, used as a fallback when no osg::Image is attached to provide the source image format.

void osg::Texture::setUnRefImageDataAfterApply | ( | bool | flag | ) | `[inline]`

| Sets whether or not the apply() function will unreference the image data. If enabled, and the image data is only referened by this Texture, apply() will delete the image data.

void osg::Texture::setUseHardwareMipMapGeneration | ( | bool | useHardwareMipMapGeneration | ) | `[inline]`

| Sets the hardware mipmap generation hint. If enabled, it will only be used if supported in the graphics system.

void osg::Texture::setWrap | ( | WrapParameter | which,
|  | WrapMode | wrap
| ) |

| Sets the texture wrap mode.

void osg::Texture::takeTextureObjects | ( | TextureObjectListMap & | toblm | ) |

| Takes the active texture objects from the Texture and places them in the specified TextureObjectListMap.

## Member Data Documentation

Vec4 osg::Texture::_borderColor`[protected]`

GLint osg::Texture::_borderWidth`[protected]`

bool osg::Texture::_clientStorageHint`[protected]`

GLint osg::Texture::_internalFormat`[mutable, protected]`

InternalFormatMode osg::Texture::_internalFormatMode`[protected]`

FilterMode osg::Texture::_mag_filter`[protected]`

float osg::Texture::_maxAnisotropy`[protected]`

FilterMode osg::Texture::_min_filter`[protected]`

ref_ptr<GraphicsContext> osg::Texture::_readPBuffer`[mutable, protected]`

bool osg::Texture::_resizeNonPowerOfTwoHint`[protected]`

float osg::Texture::_shadow_ambient`[protected]`

ShadowCompareFunc osg::Texture::_shadow_compare_func`[protected]`

ShadowTextureMode osg::Texture::_shadow_texture_mode`[protected]`

GLenum osg::Texture::_sourceFormat`[mutable, protected]`

GLenum osg::Texture::_sourceType`[mutable, protected]`

TexParameterDirtyList osg::Texture::_texParametersDirtyList`[mutable, protected]`

TextureObjectBuffer osg::Texture::_textureObjectBuffer`[mutable, protected]`

bool osg::Texture::_unrefImageDataAfterApply`[protected]`

bool osg::Texture::_use_shadow_comparison`[protected]`

bool osg::Texture::_useHardwareMipMapGeneration`[protected]`

WrapMode osg::Texture::_wrap_r`[protected]`

WrapMode osg::Texture::_wrap_s`[protected]`

WrapMode osg::Texture::_wrap_t`[protected]`

unsigned int osg::Texture::s_numberDeletedTextureInLastFrame`[static]`

unsigned int osg::Texture::s_numberNewTextureInLastFrame`[static]`

unsigned int osg::Texture::s_numberTextureReusedLastInLastFrame`[static]`

The documentation for this class was generated from the following file:

- Texture